unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Shlobj,
  StdCtrls, FoldrDlg,  ExtCtrls;

type
  TMainForm = class(TForm)
    btnBrowse: TButton;
    DirectoryEdit: TEdit;
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    TemplateCheckBox: TCheckBox;
    TemplateButton: TButton;
    TemplateRadioButton: TRadioButton;
    btnClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnBrowseClick(Sender: TObject);
    procedure CustomButtonClick(Sender: TObject);
  private
    FolderDialog1: TFolderDialog;
    FTemplateButtons: array[0..2] of TButtonControl;
    procedure FolderDialog1Show(Sender: TObject);
    procedure FolderDialog1Change(Sender: TObject);
    procedure FolderDialog1Close(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

const
  CrLf = chr($D)+chr($A);

procedure TMainForm.btnBrowseClick(Sender: TObject);
begin
  FolderDialog1.Directory:= DirectoryEdit.Text;
  if FolderDialog1.Execute then
    DirectoryEdit.Text:= FolderDialog1.Directory
  else
    DirectoryEdit.Text:= '';
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.RadioGroup1Click(Sender: TObject);
begin
  FolderDialog1.CustomButton:= FTemplateButtons[RadioGroup1.ItemIndex]
end;

procedure TMainForm.CustomButtonClick(Sender: TObject);
var
  I: integer;
begin
  for I:= 0 to 2 do
    if Sender = FTemplateButtons[I] then
    begin
      RadioGroup1.ItemIndex:= I;
      RadioGroup1Click(Sender);
      break;
    end;

  MessageDlg('The properties of the CustomButton in a TFolderDialog'+
    ' are controlled by the properties of a template button. The'+
    ' template button may be invisible and can be assigned to'+
    ' property CustomButton at design-time.'+
    CrLf+CrLf+'This OnClick event is used too.'+
    CrLf+CrLf+'Current selection is ' + FolderDialog1.Directory +
    CrLf+CrLf+'Client = ' +
           IntToStr(FolderDialog1.ClientWidth)+','+
           IntToStr(FolderDialog1.ClientHeight),
    mtInformation,[mbOK],0);
end;

procedure TMainForm.FolderDialog1Show(Sender: TObject);
begin
 { resize common dialog for fun: contained controls are not aligned }
  with FolderDialog1 do
    SetWindowPos(Handle, 0, 0, 0, ClientWidth+80, ClientHeight+40,
        SWP_NOACTIVATE or SWP_NOCOPYBITS or SWP_NOMOVE or
        SWP_NOZORDER);
end;

procedure TMainForm.FolderDialog1Change(Sender: TObject);
begin
 { with Sender as TFolderDialog do
    ShowMessage('New Selection = '+Directory); }
end;

procedure TMainForm.FolderDialog1Close(Sender: TObject);
begin
  ShowMessage('FolderDialog1Close');
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.Title:= Caption;

  FTemplateButtons[0]:= TemplateButton;
  FTemplateButtons[1]:= TemplateCheckBox;
  FTemplateButtons[2]:= TemplateRadioButton;

  FolderDialog1:= TFolderDialog.Create(Self);
  with FolderDialog1 do
  begin
    { default options are: [bfFileSysDirsOnly, bfStatusText,
         bfShowPathInStatusArea, bfSyncCustomButton,
         bfAlignCustomButton, bfParentCenter] }
//  Options := Options + [bfDontGoBelowDomain, bfScreenCenter];
//  Options:= Options + [bfBrowseIncludeFiles];
//  RootFolder:= sfoSendto{sfoStartMenu};
    Title := 'Select Item From Shell''s Namespace';
    Text := 'Choose a long path in the shell''s treeview to see how '+
            'next StatusLine is compacted:';
    CustomButton:= TemplateButton;
    OnShow := FolderDialog1Show;
    OnChange := FolderDialog1Change;
    OnClose := FolderDialog1Close;
  end;
end;

end.
